#! /usr/bin/gawk -f

# Írj olyan AWK scriptet, ami kiszűri a helyes email címeket a helytelenek közül!
# Az általunk által kitalált szabályok szerint egy email cím a következőképpen néz ki:
# -az email címek [basename]@[domain].[top-level_domain] alakúak
# -a [basename] csak a következő speciális karaktereket tartalmazhatja: ._+-!?, de ezekkel nem kezdődhet!
# -a [domain] csak a - speciális karaktert tartalmazhatja
# -a [top-level_domain] csak kisbetűket és számokat tartalmazhat, valamint hossza 2 és 3 közé kell essen hogy

$1~/^([A-Za-z0-9]+)([A-Za-z0-9_.-]|\!\?|\+)*@[A-za-z0-9-]+\.([a-z]{2,3})$/{
	print $1
}

# Valójában az email címek az RFC 5322 standard lapján határozhatók meg: https://en.wikipedia.org/wiki/Email_address
#	(?:[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*
#	|  "(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21\x23-\x5b\x5d-\x7f]
#	|  \\[\x01-\x09\x0b\x0c\x0e-\x7f])*")
#	@ (?:(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?
#	|  \[(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}
#	(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?|[a-z0-9-]*[a-z0-9]:(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21-\x5a\x53-\x7f]
#	|  \\[\x01-\x09\x0b\x0c\x0e-\x7f])+)\])
